freeze;

/*
 * Computing with Lie algebras generated by extremal elements.
 *
 * Removing basis elements after computing them.
 *
 * Dan Roozemond, 2010.
 */
intrinsic RemoveBasisElt(L::AlgLieExtr, i::RngIntElt) -> AlgLieExtr
{ Remove the i-th basis elt, declaring it to be 0}
	if not assigned L`Dimension then
		error "You should compute the basis first";
	end if;
	d := L`Dimension;
	F := L`OrigBaseRing;
	V := VectorSpace(F, d);
	return RemoveBasisElt(L, i, V!0);
end intrinsic;

