
freeze;

/*
> H:=HypergeometricData([6],[1,1]);
> EulerFactor(H,7^6,7);
7*x^2 - 5*x + 1
> H:=HypergeometricData([3,4,6,12],[1,1,5,5]);  
> EulerFactor(H,13^12,13);                  
371293*x^10 - 285610*x^9 + 125229*x^8 - 31096*x^7 +
 4810*x^6 - 540*x^5 + 370*x^4 - 184*x^3 + 57*x^2 - 10*x + 1
*/

Z:=Integers(); Q:=Rationals(); PSR:=PowerSeriesRing;
teich:=func<x|x*Exp(-Log(x^(p-1))/(p-1)) where p:=Prime(Parent(x))>;

function tame_euler(X,t,p,m,PREC) x:=PolynomialRing(Z).1; w:=Weight(X);
 if m eq 1 then res:=1-p^((1+w-Multiplicity(X`cycB,1)) div 2)*x; // p^X`dvalue
  return PREC lt Degree(X) select PSR(Q,PREC+1)!res else res; end if;
 f:=1; while p^f mod m ne 1 do f:=f+1; end while;
 if f gt PREC then return 1+O(PSR(Q,PREC+1).1^(PREC+1)); end if;
 e:=EulerPhi(m); mx:=Max([Binomial(e,d)*p^(d*X`weight/2) : d in [0..e]]);
 pr:=Ceiling(Log(2*Floor(mx+1.01))/Log(p)); K:=pAdicField(p,pr);
 if p eq 2 then T:=1; else T:=teich(t*X`Mvalue*K.1); end if;
 KK:=pAdicQuotientRing(p,pr); T:=KK!T; q:=p^f; assert (q-1) mod m eq 0;
 Y:=(q-1) div m; E:=[Y*d : d in [1..m-1] | Gcd(d,m) eq 1] cat [pr]; // pr hack
 R:=HypgeomMotExtract(X`fps,X`Garray,(Z!T) mod (p^pr),p^f,X`dvalue,E);
 Sort(~R); R:=[K!R[f*(i-1)+1] : i in [1..#R div f]];
 x:=PolynomialRing(Universe(R)).1; ans:=&*[x^f-r : r in R];
 res:=Polynomial(Reverse(ChangeUniverse(Coefficients(ans),Z)));
 return PREC lt Degree(X) select PSR(Q,PREC+1)!res else res; end function;

function getf(p,m) if m eq 1 then return 1; end if;
 f:=1; while p^f mod m ne 1 do f:=f+1; end while; return f; end function;

function ef_tame(X,t,p,PREC) v,t0:=Valuation(t,p);
 if PREC eq 0 then PREC:=Degree(X); end if;
 AB:=Set([x : x in (v gt 0 select X`cycA else X`cycB) | v mod x eq 0]);
 if #AB eq 0 then return PolynomialRing(Z)!1; end if;
 o:=Max([getf(p,m) : m in AB]); if o le PREC then PREC:=10000; end if;
 res:=&*[tame_euler(X,t0,p,m,PREC) : m in AB]; return res; end function;

function tame_cond(X,t,p) v:=Valuation(t,p);
 AB:=Set([x : x in (v gt 0 select X`cycA else X`cycB) | v mod x eq 0]);
 return Degree(X)-&+[Z|EulerPhi(d) : d in AB]; end function;

function hgm_trace(X,q,t) b,p,f:=IsPrimePower(q);
 pr:=Ceiling(Log(2*Floor(#X`alpha*q^(X`weight/2)+1))/Log(p));
 K:=pAdicField(p,pr);
 if p eq 2 then T:=1; else T:=teich(t*X`Mvalue*K.1); end if;
 KK:=pAdicQuotientRing(p,pr); T:=KK!T;
 if q ne 2 then
  s:=HypgeomMotHelper(X`fps,X`Garray,(Z!T) mod (p^pr),p^f,pr,X`dvalue);
  else s:=0; end if; // sum is empty when q is 2;
 return Integers()!((q^X`dvalue+s)*KK!(1/(1-q))); end function;

////////////////////////////////////

function doit_odddeg(H) A:=H`cycA; B:=H`cycB; // Phi_2 in A, Phi_1 in B
 X:=&*[Z|&*PrimeFactors(a) : a in A |
	Valuation(a,2) eq 0 and a ne 1 and IsPrimePower(a)];  // odd alpha
 X*:=&*[Z|2 : a in A | a ge 4 and IsPowerOf(a,2)];
 Y:=&*[Z|&*PrimeFactors(b div 2) : b in B |
	Valuation(b,2) eq 1 and b ne 2 and IsPrimePower(b div 2)]; // even beta
 Y*:=&*[Z|2 : b in B | b ge 4 and IsPowerOf(b,2)];
 return (-1)^((#H`alpha-1) div 2)*X*Y; end function;
/* this is \prod_v v^Gamma[v] with Gamma from (alpha,beta+1/2) */

function doit_evendeg_oddwt(X) A:=X`cycA; B:=X`cycB; // Phi_1 in B, even mult
 X:=&*[Z|&*PrimeFactors(a) : a in A |
	Valuation(a,2) eq 0 and a ne 1 and IsPrimePower(a)];  // odd alpha
 X*:=&*[Z|2 : a in A | a ge 4 and IsPowerOf(a,2)]; 
 Y:=&*[Z|&*PrimeFactors(b) : b in B |
	Valuation(b,2) eq 0 and b ne 1 and IsPrimePower(b)];  // odd beta
 Y*:=&*[Z|2 : b in B | b ge 4 and IsPowerOf(b,2)]; 
 return (-1)^(Multiplicity(B,1) div 2)*X*Y; end function; 
/* FRV notes this is \prod_v v^Gamma[v] */

function doit_evendeg_evenwt(H) A:=H`cycA; B:=H`cycB; // Phi_1 in B, odd mult
 X:=&*[Z|&*PrimeFactors(a div 2) : a in A |
	Valuation(a,2) eq 1 and a ne 2 and IsPrimePower(a div 2)]; // ev alpha
 X*:=&*[Z|2 : a in A | a ge 4 and IsPowerOf(a,2)]; 
 Y:=&*[Z|&*PrimeFactors(b) : b in B |
	Valuation(b,2) eq 0 and b ne 1 and IsPrimePower(b)]; // odd beta
 Y*:=&*[Z|2 : b in B | b ge 4 and IsPowerOf(b,2)]; 
 return -(-1)^(#H`alpha div 2)*(-1)^((Multiplicity(B,1)-1) div 2)*X*Y;
 end function;
/* this is 2*\prod_v v^Gamma[v] with Gamma from (alpha+1/2,beta) */

function doit_evendeg(X)
 return IsOdd(Weight(X))
  select doit_evendeg_oddwt(X) else  doit_evendeg_evenwt(X); end function;

function doit_degree(X)
 return IsOdd(Degree(X)) select doit_odddeg(X) else doit_evendeg(X);
 end function;

function ef_mul(X,t,p,Precision,Check) deg:=#X`alpha;
 if IsOdd(deg) then // necessarily even weight
  if Precision eq 0 then prec:=deg div 2; else prec:=Precision; end if;
  eps:=KroneckerCharacter(doit_odddeg(X))(p);
  lim:=(deg div 2)-(eps eq -1 select 1 else 0);
  if not Check then PREC:=Min(prec,lim); else PREC:=prec; end if;
  P:=PowerSeriesRing(Rationals(),PREC+1); T:=P.1;
  f:=Exp(-&+[P|Integers()!hgm_trace(X,p^i,t)*T^i/i : i in [1..PREC]]);
  if PREC eq lim then g:=Polynomial(Coefficients(f));
   if (eps eq +1) then lim:=lim-1; end if;
   for d in [0..lim] do g:=g+eps*Parent(g).1^(deg-1-d)*Coefficient(g,d)
			        *p^((X`weight*(deg-1-2*d)) div 2); end for;
  else g:=f; end if;
 else // even degree, could be either weight
  if Check then
   if Precision eq 0 then PREC:=deg-1; else PREC:=Precision; end if;
   P:=PowerSeriesRing(Rationals(),PREC+1); T:=P.1;
   f:=Exp(-&+[P|Integers()!hgm_trace(X,p^i,t)*T^i/i : i in [1..PREC]]); g:=f;
  else // use functional equation
   if Precision eq 0 then prec:=(deg-2) div 2; else prec:=Precision; end if;
   lim:=(deg-2) div 2; PREC:=Min(prec,lim);
   P:=PowerSeriesRing(Rationals(),Max(2,PREC+1)); T:=P.1;
   eps:=KroneckerCharacter(doit_evendeg(X))(p); f1:=1-eps*T*p^(X`weight div 2);
   f:=Exp(-&+[P|Integers()!hgm_trace(X,p^i,t)*T^i/i : i in [1..PREC]]);
   if PREC eq lim then g:=Polynomial(Coefficients(f/f1+O(T^(PREC+1))));
    for d in [0..lim-1] do g:=g+1*Parent(g).1^(deg-2-d)*Coefficient(g,d)
   			         *p^(((X`weight)*(deg-2-2*d)) div 2); end for;
    g:=g*Polynomial(Coefficients(f1)); else g:=f; end if; end if; end if;
 v,t0:=Valuation(t-1,p); w:=Weight(X);
 if IsEven(Weight(X)) and IsEven(v) then m1:=Multiplicity(X`cycB,1);
  K:=(-1)^((m1-1) div 2)*2*&*[Abs(x) : x in GammaList(X)]; T:=Parent(g).1;
  g:=g*(1-KroneckerCharacter(K*t0)(p)*p^(w div 2)*T); end if;
 return PREC eq lim select PolynomialRing(Z)!g else g; end function;

////////////////////////////////////

function ef_good(X,t,p,Precision,Check) deg:=#X`alpha; // 2 is never good
 if Precision eq 0 then prec:=(deg+1) div 2; else prec:=Precision; end if;
 eps:=KroneckerCharacter(Evaluate(X`char,t))(p);
 if deg mod 2 eq 1 then lim:=(deg-1) div 2;
 else lim:=deg div 2-(eps eq -1 select 1 else 0); end if;
 if not Check then PREC:=Min(prec,lim); else PREC:=prec; end if;
 P:=PowerSeriesRing(Rationals(),PREC+1); T:=P.1;
 f:=Exp(-&+[P|Integers()!hgm_trace(X,p^i,t)*T^i/i : i in [1..PREC]]);
 if PREC ne lim then return f; end if; g:=Polynomial(Coefficients(f));
 if deg mod 2 eq 0 and (eps eq +1) then lim:=lim-1; end if;
 for d in [0..lim] do g:=g+(-1)^deg*eps*Parent(g).1^(deg-d)*Coefficient(g,d)
			           *p^((X`weight*(deg-2*d)) div 2); end for;
 return PolynomialRing(Z)!g; end function;

function ef_fake(X,t,p,Precision) deg:=#X`alpha; // utility, don't use func eq
 if Precision eq 0 then prec:=deg; else prec:=Precision; end if;
 PREC:=prec; P:=PowerSeriesRing(Rationals(),PREC+1); T:=P.1;
 f:=Exp(-&+[P|Integers()!hgm_trace(X,p^i,t)*T^i/i : i in [1..PREC]]);
 if PREC ne deg then return f; end if;
 return PolynomialRing(Z)!Polynomial(Coefficients(f)); end function;

intrinsic EulerFactor
(X::HypGeomData,t::FldRatElt,p::RngIntElt :
 Precision:=0,Check:=false,Fake:=false) -> .
{The pth Euler factor of the hypergeometic motive specialised at t}
 require t ne 0 and t ne 1: "t must be neither 0 nor 1";
 require Type(Precision) eq RngIntElt and Precision ge 0: "Precision error";
 require IsPrime(p): "p must be a prime"; deg:=#X`alpha;
 if Fake then require Valuation(MValue(X)*t,p) eq 0: "v_p(Mt) must be 0";
  return ef_fake(X,t,p,Precision); end if;
 require Valuation(X`bad,p) eq 0: "p cannot divide cyclotomic data";
 if Valuation(t,p) ne 0 then return ef_tame(X,t,p,Precision); end if;
 if Valuation(Numerator(t-1),p) ne 0 then return ef_mul(X,t,p,Precision,Check);
 else return ef_good(X,t,p,Precision,Check); end if; end intrinsic;

intrinsic EulerFactor
(X::HypGeomData,t::RngIntElt,p::RngIntElt :
 Precision:=0,Check:=false,Fake:=false)->. {"}//"
 return EulerFactor(X,Rationals()!t,p :
		  Precision:=Precision,Check:=Check,Fake:=Fake); end intrinsic;

////////////////////////////////////////////////////////////////////////

R:=PolynomialRing(Integers());
function unknown_lseries(X,t,BadPrimes,GAMMA) BAD:=AssociativeArray();
 for DATA in BadPrimes do BAD[DATA[1]]:=<DATA[2],DATA[3]>; end for;
 cffun:=function(p,d) if IsDefined(BAD,p) then return BAD[p][2]; end if;
                      if Valuation(X`bad,p) ne 0 then return R!1; end if;
                      return EulerFactor(X,t,p : Precision:=d); end function;
 Poo:=[f[1] : f in Factorization(Denominator(t))];
 P0:=[f[1] : f in Factorization(Numerator(t))];
 P1:=[f[1] : f in Factorization(Numerator(t-1))];
 K:=Keys(BAD); N:=&*[Integers() | p^BAD[p][1] : p in K];
 N*:=&*[Integers() | p^tame_cond(X,t,p) : p in Poo | not p in K];
 N*:=&*[Integers() | p^tame_cond(X,t,p) : p in P0 | not p in K];
 M:=[Integers() | p : p in P1 | not p in K];
 if IsEven(Weight(X)) then M:=[p : p in M | IsOdd(Valuation(t-1,p))]; end if;
 if #M ne 0 then N*:=&*M; end if;
 if #GAMMA eq 0 then f:=Numerator(X`hodge);
  for i in [0..(Degree(f)-1) div 2] do
   GAMMA cat:=[[0-i,1-i] : c in [1..Z!Coefficient(f,i)]]; end for;
  if IsEven(Degree(f)) then d:=Degree(f) div 2; c:=Z!Coefficient(f,d);
   if IsOdd(c) then // odd degree
    if t ge 0 and t le 1 then cp:=(c-1) div 2; cm:=(c+1) div 2;
    else cp:=(c+1) div 2; cm:=(c-1) div 2; end if; end if;
   if IsEven(c) then // even degree
    if t le 1 then cp:=c div 2; cm:=c div 2;
    else cp:=(c div 2)+1; cm:=(c div 2)-1; end if; end if;
   if IsOdd(X`dvalue+(X`weight div 2)) then zz:=cp; cp:=cm; cm:=zz; end if;
   GAMMA cat:=[[0-d : i in [1..cp]]]; GAMMA cat:=[[1-d : i in [1..cm]]];
   end if; GAMMA:=&cat GAMMA; end if;
 S:=<"L-function for parameter ",t," of ",X>;
 return LSeries(X`weight+1,GAMMA,N,cffun : Parent:=X, Name:=S); end function;

function PrimeFactors(x)
 if Type(x) eq FldRatElt then return
  PrimeFactors(Numerator(x)) join PrimeFactors(Denominator(x)); end if;
 return {t[1] : t in Factorization(x)}; end function;

IDENTIFY:=Identify;
intrinsic LSeries
(X::HypGeomData,t::FldRatElt : BadPrimes:=[],GAMMA:=[],Identify:=true) -> LSer
{The L-series of a hypergeometric motive specialised at t}
 require t ne 0 and t ne 1: "t must be neither 0 nor 1";
 require #GAMMA eq 0 or (Type(GAMMA) eq SeqEnum and Universe(GAMMA) eq Z):
 "GAMMA not SeqEnum[Z]";
 require #GAMMA eq 0 or #GAMMA eq #X`alpha: "GAMMA not the right length";
 require &and[IsPrime(b[1]) : b in BadPrimes]: "Not a prime in BadPrimes";
 require &and[IsCoercible(Z,b[2]) : b in BadPrimes]: "BadPrime N not in Z?";
 require &and[b[2] ge 0 : b in BadPrimes]: "BadPrime conductors must be >= 0";
 if Identify then
  if X`weight eq 0 then A:=ArtinRepresentation(X,t);
   if Type(A) ne BoolElt then return LSeries(A); end if; end if;
  if #X`alpha eq 2 and X`weight eq 1 then
   return LSeries(EllipticCurve(X,t)); end if;
  if X`weight eq 1 then T:=IDENTIFY(X,t);
   if Type(T) in {CrvHyp,CrvEll} then return LSeries(T); end if;
   if Type(T) eq SeqEnum then return &*[LSeries(X) : X in T]; end if; end if;
  end if;
 KNOWN_BAD:=PrimeFactors(X`bad); GIVEN_BAD:={x[1] : x in BadPrimes};
 if not (KNOWN_BAD subset GIVEN_BAD) then
  "WARNING: Guessing wild prime information"; end if;
 return unknown_lseries(X,t,BadPrimes,GAMMA); end intrinsic;

intrinsic LSeries(X::HypGeomData,t::RngIntElt :
		  BadPrimes:=[],GAMMA:=[],Identify:=true) -> LSer {"}//"
 return LSeries(X,Q!t : BadPrimes:=BadPrimes,GAMMA:=GAMMA,Identify:=Identify);
 end intrinsic;
