freeze;

// charp_orth.m 
// Csaba Schneider
  /* 
  The file contains the functions that are necessary for rewriting
  Omega* groups in the defining characteristic situation. 
  */
  
import "bbclassical.m":B, Evaluate2;
import "unipotent.m":UnipotentStabiliser;
import "MatrixPGroup.m":MatrixPGroupWordInGen;
import "orth_minus.m": OmegaMinusWordInGen;
import "orth_circle.m": OmegaCircleWordInGen;

  
U_ := function( d, q )
    
    F := GF( q ); 
    qq := #F; e := Degree( F ); 
    w := PrimitiveElement( F );
        
    QQ := ClassicalStandardGenerators( "Omega", d, qq );
    G := sub< GL( d, q ) | QQ >;
    
    v := QQ[4]; pv := B.4;
    
    if IsOdd((d+1) div 2) then
        t := (GL(d, GF(qq))!(v^-1 * QQ[2]*v))^-1;
        s := (GL(d, GF(qq))!(v^-1 * QQ[1]*v))^-1;
        pt := B.4^-1*B.2^-1*B.4;
        ps := B.4^-1*B.1^-1*B.4;
    else
        t := GL(d, GF(qq))!(v^-1 * QQ[2]*v);
        s := GL(d, GF(qq))!(v^-1 * QQ[1]*v);
        pt := B.4^-1*B.2*B.4;
        ps := B.4^-1*B.1*B.4;
    end if;
    
    r := t^s; pr := pt^ps;
    BB := (t^v)^-1*t^((qq-1) div 2)*t^v;
    pBB := (pt^pv)^-1*pt^((qq-1) div 2)*pt^pv;
    a := BB[1, d];
    
    Z := IntegerRing();
    n := Z!(-a/2);
    
    t2 := t^n*(t^v)^-1*t^((qq-1) div 2)*t^v;
    r2 := (r^n*(r^v)^-1*r^((qq-1) div 2)*r^v)^-1;
    
    pt2 := pt^n*(pt^pv)^-1*pt^((qq-1) div 2)*pt^pv;
    pr2 := (pr^n*(pr^pv)^-1*pr^((qq-1) div 2)*pr^pv)^-1;
      
    BB := ((t*s)^v)^-1*t^((qq-1) div 2)*(t*s)^v;
    pBB := ((pt*ps)^pv)^-1*pt^((qq-1) div 2)*(pt*ps)^pv;
    
    a := BB[1, d];
    n := Z!(-a/2);
    
    t1 := (t^n*((t*s)^v)^-1*t^((qq-1) div 2)*(t*s)^v)^-1;
    r1 := (r^n*((r*s)^v)^-1*r^((qq-1) div 2)*(r*s)^v);
    
    u := (r1^(t1^-1)*r1^2)^-1;
    
    pt1 := (pt^n*((pt*ps)^pv)^-1*pt^((qq-1) div 2)*(pt*ps)^pv)^-1;
    pr1 := (pr^n*((pr*ps)^pv)^-1*pr^((qq-1) div 2)*(pr*ps)^pv);
    
    pu := (pr1^(pt1^-1)*pr1^2)^-1;
    
    KQ := [];
    if d ne 3 then
        Append(~KQ, r1);
        Append(~KQ, r2^-1);
        for i in [1..(d div 2) - 2] do
            if IsOdd(i) then j := 1; else j := -1; end if;
            Append(~KQ, (r1^((v*u)^i))^-j);
            Append(~KQ, (r2^((v*u)^i))^j);
        end for;
    end if;
    
    FF := sub<F|w^2>;
    py := FF!w;
    delta := QQ[3]^QQ[4];
    
    pdelta := B.3^B.4;
    
    
    Ot1 := Id(G); pOt1 := One( B );
    for i in [1..e] do
        Ot1 := Ot1*(t1^(delta^-(i-1)))^Z!Eltseq(py)[i];
        pOt1 := pOt1*(pt1^(pdelta^-(i-1)))^Z!Eltseq(py)[i];
    end for;
    
    Or1 := Id(G); pOr1 := One( B );
    for i in [1..e] do
        Or1 := Or1*(r1^(delta^(i-1)))^Z!Eltseq(py)[i];
        pOr1 := pOr1*(pr1^(pdelta^(i-1)))^Z!Eltseq(py)[i];
    end for;
    
    Ot2 := Id(G); pOt2 := One( B );
    for i in [1..e] do
        Ot2 := Ot2*(t2^(delta^-(i-1)))^Z!Eltseq(py)[i];
        pOt2 := pOt2*(pt2^(pdelta^-(i-1)))^Z!Eltseq(py)[i];
    end for;
    
    Or2 := Id(G); pOr2 := One( B );
    for i in [1..e] do
        Or2 := Or2*(r2^(delta^(i-1)))^Z!Eltseq(py)[i];
        pOr2 := pOr2*(pr2^(pdelta^(i-1)))^Z!Eltseq(py)[i];
    end for;
    
    delta1 := r1*delta*t1;
    pdelta1 := pr1*pdelta*pt1;
    
    for j in [1..e] do
        a := Z!Eltseq((w^-1 - 1))[j];
        if IsOdd(j) then
            delta1 := delta1*(r1^(delta^((j-1) div 2)))^a;
            pdelta1 := pdelta1*(pr1^(pdelta^((j-1) div 2)))^a;
        else
            delta1 := delta1*(Or1^(delta^((j-2) div 2)))^a;
            pdelta1 := pdelta1*(pOr1^(pdelta^((j-2) div 2)))^a;
        end if;
    end for;
    
    delta1 := delta1*Ot1^-1;
    pdelta1 := pdelta1*pOt1^-1;
    
    b := delta1[3, 1];
    for j in [1..e] do
        a := Z!Eltseq(-b/w)[j];
        if IsOdd(j) then
            delta1 := delta1*(r1^(delta^((j-1) div 2)))^a;
            pdelta1 := pdelta1*(pr1^(pdelta^((j-1) div 2)))^a;
        else
            delta1 := delta1*(Or1^(delta^((j-2) div 2)))^a;
            pdelta1 := pdelta1*(pOr1^(pdelta^((j-2) div 2)))^a;
        end if;
    end for;
    
    delta2 := ((delta1^u)^s)^u;
    pdelta2 := ((pdelta1^pu)^ps)^pu;
   
    return pu, pdelta1, pdelta2;
end function;
  
    
Xr2_ := function( dim, q )
    
  gens := ClassicalStandardGenerators( "Omega-", dim, q );  
  
  if #gens eq 4 then
      Append( ~gens, gens[4] );
  end if;
    
  if IsOdd( q ) then  
      r := gens[2]^gens[5]; pr := B.2^B.5;
  else
      r := gens[1]^gens[5]; pr := B.1^B.5;
  end if;
  
  i1 := dim-1; i2 := dim;

  bas := [ [r[1,i1], r[1,i2]] ]; baspr := [ pr ];
  
  p := PrimeBasis( q )[1];
  d := Round( Log( p, q ));
  
  for i in [1..2*d-1] do
      r := r^gens[3];
      pr := pr^B.3;
      Append( ~bas, [r[1,i1],r[1,i2]] );
      Append( ~baspr, pr );
  end for;
  
  V := VectorSpace( GF( q ), 2 );
  V1, a := KSpace( V, GF( p ));
  
  mat := [];
  for i in bas do
      Append( ~mat, Coordinates( V1, i@a ));
  end for;
  
  mat := GL( 2*d, p )!mat;
  
  coeff := ((V![0,1])@a)^(mat^-1);
  
  prog := One( B );
  
  for i in [1..2*d] do
      prog := prog*baspr[i]^(Integers()!coeff[i]);
  end for;
  
  return prog;
  
end function;


// returns the element e1 -> e1+e2, ei -> ei, fi -> fi, f2 -> f2+-f1 
  
X12OMinusChar2_ := function( d, q );

   F := GF( q );
   Q := ClassicalStandardGenerators( "Omega-", d, #F );
                
   if #Q eq 4 then
    Append( ~Q, Q[4] );
   end if;             
                
   G := sub< GL( d,q ) | Q >;
   Q := [GL(d, F)!Q[i] : i in [1..#Q]];
   GGG := sub<GL(d, F)|Q>;
   ww := PrimitiveElement(GF(#F^2));
   w := PrimitiveElement(F);
   sl := SL(2, #F^2);
   /* QO := CreateOmegaPlusGenerators(OmegaPlus(d, F)); */
   e := Degree(F);
   ee := Degree(GF(#F^2));
   q := #F;
   Z := IntegerRing();

   tt := GL(d, F)!Q[1];
   rr := GL(d, F)!Q[2];
   ddelta := GL(d, F)!Q[3];
   u := GL(d, F)!Q[4];
   v := GL(d, F)!Q[5];

   /* #Q should ALWAYS be 5. The fact that it's not in
      standard.m needs to be changed */
   SS := SLPGroup(5);

   if IsOdd(d div 2) then
      t := (GL(d, F)!(v^-1 * tt*v))^-1;
      T := (SS.1 ^ SS.5)^-1;
      r := (GL(d, F)!(v^-1 * rr*v))^-1;
      R := (SS.2 ^ SS.5)^-1;
   else
      t := GL(d, F)!(v^-1 * tt*v);
      T := SS.1 ^ SS.5;
      r := GL(d, F)!(v^-1 * rr*v);
      R := SS.2 ^ SS.5;
   end if;

   delta := GL(d, F)!(v^-1 * ddelta*v);
   DELTA := SS.3 ^ SS.5;
   s := r*t^-1*r;
   S := R*T^-1*R;

   /* We now find the generators of OmegaPlus(d-2, q)
      as words in the generators for OmegaMinus(d, q).

      t^n sends col d-1 to d-1 + n*col 1 and
      col 2 to n^2*col 1 2n*col d-1 + col 2.
   
      Let a = [1, 1], b = [1, d-1], c = [1, 2].
      We need to solve an^2 + 2bn + c = 0 in order
      to get the power of n we need to kill the
      [1, 2] position
   */

   r2bar := r*((r^delta)^(r^v))^(delta^-1);
   R2bar := R*((R^DELTA)^(R^SS.5))^(DELTA^-1);
   /* zz := Log(r2[4, 1]); */
   if (d ne 4) and (d ne 2) then
      zz := Eltseq(r2bar[4, 1]^-1);
   else
      zz := Eltseq(F!1);
   end if;
   r2 := Id(G);
   R2 := Id(SS);
   for i in [1..#zz] do
      if zz[i] eq 1 then
         r2 := r2 * r2bar^(delta^(i-1));
         R2 := R2 * R2bar^(DELTA^(i-1));
      end if;
   end for;

   t2bar := t*((t^delta)^(t^v))^(delta^-1);
   T2bar := T*((T^DELTA)^(T^SS.5))^(DELTA^-1);
   t2 := Id(G);
   T2 := Id(SS);
   for i in [1..#zz] do
      if zz[i] eq 1 then
         t2 := t2 * t2bar^(delta^-(i-1));
         T2 := T2 * T2bar^(DELTA^-(i-1));
      end if;
   end for;

   r1 := t2^s;
   R1 := T2^S;
   t1 := r2^s;
   T1 := R2^S;
   
   return Evaluate( T1, [B.1,B.2,B.3,B.4,B.5]),
          Evaluate( T2, [B.1,B.2,B.3,B.4,B.5]);
end function;
    
  
X12_ := function( type, dim, q )
    
    if type eq "Omega+" then
        
        return B.5, B.2;
        
    elif type eq "Omega-" and IsEven( q ) then
        
        return X12OMinusChar2_( dim, q );
        
    elif type eq "Omega-" then
        
        gens := ClassicalStandardGenerators( "Omega-", dim, q );
        
        if #gens eq 4 then
          Append( ~gens, gens[4] );
        end if;
        
        s := gens[1]; v := gens[5]; r := gens[2];
        
        Bf :=  func< h | (h^(B.5^2))^-1*(h^B.5)^Round((q-1)/2)*h^(B.5^2) >;
        Bpf := func< h | ((h*B.1)^(B.5^2))^-1*(h^B.5)^Round((q-1)/2)*
                     (h*B.1)^(B.5^2) >;
        
        p1 := Bf(B.2); p2 := Bpf(B.2);
        x1 := Evaluate2( p1, gens ); x2 := Evaluate2( p2, gens );
        r1 := r^v; pr1 := B.2^B.5;
        
        rel := r1[1,dim-1];
        x1el := x1[1,dim-1];
        x2el := x2[1,dim-1];
        
        e1 := Integers()!(-x1el/rel); e2 := Integers()!(-x2el/rel);
        
        x1 := r1^e1*x1; x2 := r1^e2*x2;
        p1 := pr1^e1*p1; p2 := pr1^e2*p2;
        
        e1 := Integers()!(1/x1[1,4]); e2 := Integers()!(1/x2[1,3]);
        
        return p2^e2, p1^-e1;
        
    end if;
end function;
    
PSubgroupOmega := function( G )
    
    if assigned G`PSubgroup then
        return G`PSubgroup[1],  G`PSubgroup[2];
    end if; 
    
    gens := BBStandardGenerators( G );
    dim := BBDimension( G );
    q := #BBField( G );
    
    if dim eq 3 then
        dim := Dimension( G );
        F := CoefficientRing( G );
        slpgens := [B.2]; pgens := [gens[2]];
        _, _, d := IsPrimePower( q );
        for i in [1..d-1] do
            Append( ~slpgens, B.2^(B.3^i));
            Append( ~pgens, gens[2]^(gens[3]^i));
        end for;
        
        P := sub< GL( dim, F ) |  pgens >;
        G`PSubgroup := < P, slpgens >;
        return P, slpgens;
    end if;
    
    classgens := ClassicalStandardGenerators( "Omega", dim, q );
    
    
    
    Bf :=  func< h, i | (h^(B.4^i))^-1*(h^B.4)^Round((q-1)/2)*h^(B.4^i) >;
    Bpf := func< h, i | ((h*B.1)^(B.4^i))^-1*(h^B.4)^Round((q-1)/2)*
                (h*B.1)^(B.4^i) >;
    
    slpgens := [];
    pgens := [];
    pd := B.3^B.4;
    
    p := PrimeBasis( q )[1];
    e := Round( Log( p, q ));
    
    if dim mod 4 eq 1 then
        l := Integers()!( GF(p)!(-1/2));
    else
        l := Integers()!( GF(p)!(1/2));
    end if; 
    
    r := (gens[2]^gens[4])^l; v := gens[3]^gens[4]; pv := B.3^B.4;
       
    for i in [0..e-1] do
        Append( ~pgens, r^(v^i));
        Append( ~slpgens, ((B.2^B.4)^l)^(pv^i));
    end for;
    
    s := classgens[1]; v := classgens[4]; r := classgens[2];
    r1 := r^v; pr1 := (B.2^B.4);
    
    for i in [2..(dim-1)/2] do
        p2 := Bpf(B.2,i);
        x2 := Evaluate2( p2, classgens );
        pr1 := B.2^B.4;
        
        rel := r1[1,dim];
        x2el := x2[1,dim];
                
        e2 := Integers()!(-x2el/rel);
        
        x2:= r1^e2*x2;
        
        p2 := pr1^e2*p2;
        
        i2 := 2*i-1;
        e2 := Integers()!(1/x2[1,i2]);
        p2 := p2^e2;
        
        for i in [1..e] do
            Append( ~slpgens, p2 ); 
            Append( ~pgens, Evaluate2( p2, gens ));
            p2 := p2^pd;
        end for;
    end for;
    
    for i in [(dim-1)/2..2 by -1] do
        p1 := Bf(B.2,i); 
        x1 := Evaluate2( p1, classgens ); 
        
        rel := r1[1,dim];
        x1el := x1[1,dim];
                
        e1 := Integers()!(-x1el/rel); 
        
        x1 := r1^e1*x1; 
        
        p1 := pr1^e1*p1; 
        
        i1 := 2*i; 
        e1 := Integers()!(1/x1[1,i1]); 
        p1 := p1^e1; 
        
        for i in [1..e] do
            Append( ~slpgens, p1 ); 
            Append( ~pgens, Evaluate2( p1, gens )); 
            p1 := p1^pd; 
        end for;
    end for;
    
    dim := Dimension( G );
    F := CoefficientRing( G );
    P := sub< GL( dim, F ) | pgens >;
    G`PSubgroup := < P, slpgens >;
    
    return P, slpgens;
end function;
    

/* PSubgroup returns the p-core of the stabilizer of <e_2,...> and 
  its generators as SLPs in the standard generators. */
  
PSubgroupOmegaMinusDim4 := function( G )
    
     
    if assigned G`PSubgroup then
        return G`PSubgroup[1],  G`PSubgroup[2];
    end if; 
    
    gens := BBStandardGenerators( G );
    bbdim := BBDimension( G );
    q := #BBField( G );
    _, _, d := IsPrimePower( q );
    
    if IsOdd( q ) then
        T := gens[2]; pT := B.2; 
    else
        T := gens[1]; pT := B.1; 
    end if;
    
    D := gens[3]; pD := B.3;
    
    gens := []; pgens := [];
    
    for i in [1..2*d] do
        Append( ~gens, T^(D^i));
        Append( ~pgens, pT^(pD^i));
    end for;
    
    P := sub< GL( Dimension( G ), CoefficientRing( G )) | gens >;
    G`PSubgroup := < P, pgens >;
    
    return P, pgens;
end function;
    
PSubgroup := function( G )
    
    if assigned G`PSubgroup then
        return G`PSubgroup[1],  G`PSubgroup[2];
    end if;  
    
    type := BBType( G );
    q := #BBField( G );
    bbdim := BBDimension( G );
    
    if type eq "Omega" then
        return PSubgroupOmega( G );
    elif type eq "Omega-" and bbdim eq 4 then
        return PSubgroupOmegaMinusDim4( G );
    end if;
    
        
    gens := BBStandardGenerators( G );
    _, p, d := IsPrimePower( q );  
    
    pX1, pX2 := X12_( BBType( G ), bbdim, q );
    
    X1 := Evaluate2( pX1, gens ); X2 := Evaluate2( pX2, gens );
    
     if type eq "Omega+" then
        D := gens[6]; pD := B.6;
        p := gens[8]*gens[4]; pp := B.8*B.4;
    elif type eq "Omega-" then
        D := (gens[3]^gens[5])^Round(2*Order( gens[3] )/(q-1));
        pD := (B.3^B.5)^Round(2*Order( gens[3] )/(q-1));
        p := gens[5]*gens[4]; pp := B.5*B.4;
    end if;
    
    gensp := []; bbgens := []; 
    X11 := X1; pX11 := pX1;
    
    up := case< type | "Omega+": bbdim/2-1, "Omega-": bbdim/2-2, 
          default: false >;
    
    for i in [1..up] do
        X12 := X11;
        pX12 := pX11;
        for j in [1..d] do
            Append( ~gensp, X12 );
            Append( ~bbgens, pX12 );
            X12 := X12^D;
            pX12 := pX12^pD;
        end for;
        X11 := (X11^p)^-1; D := D^p;
        pX11 := (pX11^pp)^-1; pD := pD^pp;
    end for;
    
    if type eq "Omega-" then
        
        if IsOdd( q ) then
            r1 := (gens[2]^gens[5])^(-1)^Round(bbdim/2);
            pr1 := (B.2^B.5)^(-1)^Round(bbdim/2);
        else
            r1 := gens[1]^gens[5];
            pr1 := (B.1^B.5);
        end if;
                
        for i in [0..d-1] do
            Append( ~gensp, r1^(D^i));
            Append( ~bbgens, pr1^(pD^i));
        end for;
        
        pr2 := Xr2_( bbdim, q );
        r2 := Evaluate2( pr2, gens );
        
        for i in [0..d-1] do
            Append( ~gensp, r2^(D^i));
            Append( ~bbgens, pr2^(pD^i));
        end for;
        
    end if;
    
    p := p^-1; pp := pp^-1;
    
    if type eq "Omega+" then
         X2 := (X2^p)^(-1)^Round(bbdim/2+1); 
         pX2 := (pX2^pp)^(-1)^Round(bbdim/2+1);
    elif type eq "Omega-" then
        X2 := (X2^p)^(-1)^Round(bbdim/2); 
        pX2 := (pX2^pp)^(-1)^Round(bbdim/2);
    end if;
    X21 := X2; pX21 := pX2;
    D := gens[3]^gens[5]; pD := B.3^B.5;
    
    for i in [1..up] do
        X22 := X21;
        pX22 := pX21;
        for j in [1..d] do
            Append( ~gensp, X22 );
            Append( ~bbgens, pX22 );
            X22 := X22^D;
            pX22 := pX22^pD;
        end for;
        X21 := (X21^p)^-1; D := D^p;
        pX21 := (pX21^pp)^-1; pD := pD^pp;
    end for;
    
    P := sub< GL( Dimension( G ), CoefficientRing( G )) | gensp >;
    G`PSubgroup := < P, bbgens >;
    
    return P, bbgens;
end function;
     
StabilizerOfE1 := function( G )
    
    if assigned G`StabilizerOfE1 then
        return G`StabilizerOfE1;
    end if;
    
    dim := Dimension( G );
    bbdim := BBDimension( G );
    F := CoefficientRing( G );
    q := #F;
    gens := BBStandardGenerators( G );
    type := BBType( G );
    
    if type eq "Omega+" and BBDimension( G ) eq 4 then
        
        St := sub< GL( dim, F ) | gens[2]^gens[1], gens[3], 
              gens[5]^gens[8], gens[6] >;
    
    elif type eq "Omega+" then
    
        St := sub< GL( dim, F ) | gens[1]^gens[8], gens[2]^gens[8],
                   gens[3], gens[4]^gens[8], gens[5]^gens[8], gens[6], 
                   gens[8]*gens[4], gens[2]^gens[1] >;
        
    elif type eq "Omega-" and bbdim eq 4 and IsOdd( q ) then
        
        return sub< GL( dim, F ) | gens[2]^gens[1], gens[3] >;
        
    elif type eq "Omega-" and bbdim eq 4 and IsEven( q ) then
        
        return sub< GL( dim, F ) | gens[2], gens[3] >;
        
    elif type eq "Omega-" and bbdim eq 6 and IsOdd( q ) then
        
         return sub< GL( dim, F ) | gens[1], gens[2], gens[3],
                     gens[5]*gens[4], gens[2]^(gens[1]*gens[5]) >; 
         
     elif type eq "Omega-" and bbdim eq 6 and IsEven( q ) then
         
         return sub< GL( dim, F ) | gens[1], gens[2], gens[3],
                     gens[5]*gens[4], gens[2]^gens[5] >; 
                  
    elif type eq "Omega-" and IsOdd( #F ) then
        
        return sub< GL( dim, F ) | gens[1], gens[2], gens[3], gens[4]^gens[5],
                    gens[5]*gens[4], gens[2]^(gens[1]*gens[5]) >; 
        
    elif type eq "Omega-" and IsEven( #F ) then
        
         return sub< GL( dim, F ) | gens[1], gens[2], gens[3], gens[4]^gens[5],
                    gens[5]*gens[4], gens[2]^gens[5] >; 
        
    elif type eq "Omega" and bbdim eq 3 then
        
        return sub< GL( dim, F ) | gens[2]^gens[1], gens[3] >;
        
    elif type eq "Omega" then
        
        u, delta := U_( BBDimension( G ), #F );
        u := Evaluate2( u, gens ); delta := Evaluate2( delta, gens );
        
        return sub< GL( dim, F ) | gens[1], gens[2], 
                    gens[3], gens[4]*u,
                    gens[2]^(gens[1]*gens[4]),delta >; 
        
    end if;
    
    G`StabilizerOfE1 := St;
    return St;
end function;
    
ClearFirstRowOmegaCharP := function( G, g : FirstCall := false )
    
    gens := BBStandardGenerators( G );
    type := BBType( G );
    dim := BBDimension( G );
    S := gens[1];
    H := StabilizerOfE1( G );
    P, pgens := PSubgroup( G );
    F := BBField( G );
    
    M := GModule( H );
    U := MinimalSubmodule( M );
    
    W := VectorSpace( CoefficientRing( G ), Degree( G ));
    
    U := sub<  W | [ W!(M!x) : x in Basis( U )]>;
    St, C, x, w := UnipotentStabiliser( P, U^g : ComputeBase := false );
    St1, C1, x1, w1 := UnipotentStabiliser( P, U : ComputeBase := false );
    
    prog := One( B ); el := One( G );
    
    if FirstCall then
        
        if type eq "Omega+" then
            up := dim/2;
            R := gens[8]; pR := B.8;
            Q := gens[1]; pQ := B.1;
        elif type eq "Omega-" and dim eq 4 and IsOdd( #F ) then
            up := 1;
            R := One( G ); pR := One( B );
            Q := gens[1]; pQ := B.1;
        elif type eq "Omega-" and IsOdd( #F ) then
            up := dim/2-1;
            R := gens[5]; pR := B.5;
            Q := gens[1]^gens[5]; pQ := B.1^B.5;
        elif type eq "Omega-" and IsEven( #F ) then
            up := dim/2-1;
            R := gens[5]; pR := B.5;
            Q := (gens[1]*gens[2])^gens[5]; pQ := (B.1*B.2)^B.5;
        elif type eq "Omega" and dim gt 3 then
            up := dim/2-1;
            R := gens[4]; pR := B.4;
            Q := gens[1]^gens[4]; pQ := B.1^B.4;
        elif type eq "Omega" and dim eq 3 then
            up := 1;
            R := One( G ); pR := One( B );
            Q := gens[1]; pQ := B.1;
        end if;
        
        c := 0;
        while C ne C1 do
            c := c+1;
            if c gt dim then
                return false, false, false, false;
            end if;
            
            if c le up then
                g1 := g*R^c;
            else
                g1 := g*R^c*Q;
            end if;
            
            St, C, x, w := UnipotentStabiliser( P, U^g1 : 
                                   ComputeBase := false );
            
        end while;
        
        if c le up then
            prog := pR^c;
            el := R^c;
        else
            prog := pR^c*pQ;
            el := R^c*Q;
        end if;
    end if;
    
    p := Evaluate2( w*w1^-1, pgens );
    
    return One( B ), prog*p, One( G ), el*x*x1^-1;
end function;
    
ClearFirstRowOmegaPlusCharP := ClearFirstRowOmegaCharP;
ClearFirstRowOmegaMinusCharP := ClearFirstRowOmegaCharP;
ClearFirstRowOmegaCharP := ClearFirstRowOmegaCharP;

    
WriteTransvectionAsSLP := function( G, t : GetWE1Entry := true )
    
    dim := BBDimension( G );
    type := BBType( G );
    P, genspslp := PSubgroup( G );
    p := MatrixPGroupWordInGen( t, P : ComputeBase := false );
    p := Evaluate2( p, genspslp );
    
    stgens := ClassicalStandardGenerators( BBType( G ), dim, #BBField( G ));
                      
    if  #stgens eq 4 then
        Append( ~stgens, stgens[4] );
    end if;
    
    mat := Evaluate2( p,stgens );
    
    if type in { "Omega+", "Omega-" } then
        range := [3..dim-1 by 2] cat [dim..4 by -2];
    elif type eq "Omega" then
        range := [dim] cat [3..dim-2 by 2] cat  [dim-1..3 by -2];
    end if;
    
    vec := [ mat[1,i] : i in range ];
    
    return p, vec;
end function;  
    
SmallerMatrix := function( G, g : Method := "CharP" );
    
    dim := BBDimension( G );
    type := BBType( G );
    
    if ( type eq "Omega-" and dim eq 4 ) or type eq "Omega" and dim eq 3  then
        return One( MatrixAlgebra( BBField( G ), 2 ));
    end if;

    P := PSubgroup( G );
    _, _, d := IsPrimePower( #BBField( G ));
    R := [ P.(i*d+1) : i in [0..dim-3]];
    
    mat := [];

    for x1 in R do
        _, v := WriteTransvectionAsSLP( G, x1^g );
        Append( ~mat, v );
    end for;
        
    return MatrixAlgebra( BBField( G ), dim-2 )!mat;
end function;
    
SmallerMatrixOmegaPlus := SmallerMatrix;
SmallerMatrixOmegaMinus := SmallerMatrix;    
SmallerMatrixOmega := SmallerMatrix;


SmallerMatrixToSLPOmegaPlus4 := function( G, g, mat )
    
    F := BBField( G );
    z := PrimitiveElement( F );
    gens := BBStandardGenerators( G );
    
    delta := -SquareRoot( mat[1,1]*mat[2,2] );
    a := Log( z, mat[1,1]*delta^-1 );
    X1 := GL( 2, #F )![z,0,0,z^-1];
              
              
    return B.3^a, One( B ), One( G );
end function;
    
SmallerMatrixToSLPOmegaPlus := function( G, g, mat )
    
    dim := BBDimension( G );
    F := BBField( G );
    
    if dim eq 4 then 
        return  SmallerMatrixToSLPOmegaPlus4( G, g, mat );
    end if;
          
    
    form := 0;
    for i in [1..(dim-2)/2] do
        form := form + mat[1,i]*mat[dim-2,dim-1-i]+
                mat[1,dim-1-i]*mat[dim-2,i];
    end for;
    
    if not IsSquare( (F!form)^-1 ) then return false, false, false; end if;
    
    s := Sqrt( (F!form)^-1 );
    mat := mat*s;
    
    formmat := Zero( MatrixAlgebra( F, dim-2 ));
    for i in [1..dim-2] do
        formmat[i,dim-1-i] := 1;
    end for;
    
    if dim gt 4 and SpinorNorm( GL( dim-2, F )!mat, formmat ) ne 0 then
        mat[1] := mat[1]*PrimitiveElement( F );
        mat[dim-2] := mat[dim-2]*PrimitiveElement( F )^-1;
        prog := B.3^-1;
    else
        prog := One( B );
    end if;
    
    a, w := SOPlusWordInGen( SO( 1, dim-2, F ), GL( dim-2, F )!mat );
    assert a;
    prog := prog*Evaluate2( w, 
                     [B.1^B.8,B.2^B.8,B.3^B.8,B.4^B.8,B.5^B.8,
                      B.6^B.8,B.7^B.8,B.8*B.4^-1 ]);
    
    return prog, One( B ), One( G );
end function;
    
SmallerMatrixToSLPOmegaMinusChar2 := function( G, g, mat )
    
    
    dim := BBDimension( G );
    F := BBField( G );
    q := #F;
      
    _, _, formmat := OrthogonalForm( sub< GL( dim, q ) | 
                             ClassicalStandardGenerators( "Omega-", dim, q )>);
    w := formmat[dim-1,dim];
      
    form := 0;
    for i in [1..dim/2-2] do
        form := form + mat[1,i]*mat[dim-2,dim-i-1]+
                mat[1,dim-1-i]*mat[dim-2,i];
    end for;
    
    form := form+w*(mat[1,Round(dim/2)-1]*mat[dim-2,Round(dim/2)]+
                    mat[1,Round(dim/2)]*mat[dim-2,Round(dim/2)-1]);
    
    s := Sqrt( (F!form)^-1 );
     
    mat := mat*s;
    
     list := [];
    
    for i in [1..dim-5 by 2] do
        Append( ~list, i );
    end for;
    
    Append( ~list, dim-3 ); Append( ~list, dim-2 );
    
    for i in [dim-4..2 by -2] do
        Append( ~list, i );
    end for;
    
    p := GL( dim-2, q )!PermutationMatrix( GF( q ), Sym( dim-2 )!list );
    
    a, w := OmegaMinusWordInGen( GL( dim-2, q ), 
                    (GL( dim-2, q )!mat)^p );
    assert a;
    
    
    return Evaluate2( w, [ B.1, B.2, B.3, B.4^B.5, B.5*B.4 ]), 
           One( B ), One( G );
    
end function;
    
    
    
SmallerMatrixToSLPOmegaMinus := function( G, g, mat )
    
    dim := BBDimension( G );
    F := BBField( G );
    q := #F;
      
      
    if dim eq 4 then
        return One( B ), One( B ), One( G );
    elif IsEven( q ) then
        return SmallerMatrixToSLPOmegaMinusChar2( G, g, mat );
    end if;
      
    D := ClassicalStandardGenerators( "Omega-", dim, #F )[3];
    mat2 := Transpose( MatrixAlgebra( F, 2 )![D[dim-1,dim-1]^2,
                 D[dim-1,dim]^2,D[dim,dim-1]^2,D[dim,dim]^2]);
    
    vec := Eigenspace( mat2, 1 );
    
    b := Basis( vec )[1];
    b := -2*b/b[1];
    w1 := b[1]; w2 := b[2];
        
    form := 0;
    for i in [1..(dim-2)/2-1] do
        form := form + mat[1,i]*mat[dim-2,dim-1-i]+
                mat[1,dim-1-i]*mat[dim-2,i];
    end for;
    
    i1 := Round( dim/2-1 ); i2 := i1+1;
    form := form+mat[1,i1]*mat[dim-2,i1]*w1+mat[1,i2]*mat[dim-2,i2]*w2;
    
    if not IsSquare( (F!form)^-1 ) then return false, false, false; end if;
    
    s := Sqrt( (F!form)^-1 );
    
    mat := mat*s;
    
    formmat := Zero( MatrixAlgebra( F, dim-2 ));
    for i in [1..dim/2-2] do
        formmat[i,dim-1-i] := 1;
    end for;
    
    i1 := Round( dim/2-1 ); i2 := i1+1;
    formmat[i1,i1] := w1; formmat[i2,i2] := w2;
        
    for i in [dim/2+1..dim-2] do
        formmat[i,dim-1-i] := 1;
    end for;
    
    if SpinorNorm( GL( dim-2, F )!mat, formmat ) ne 0 then
        mat2 := One( MatrixAlgebra( F, dim-2 ));
        mat2[i1,i1] := D[dim-1,dim-1];
        mat2[i1,i2] := D[dim-1,dim];
        mat2[i2,i1] := D[dim,dim-1];
        mat2[i2,i2] := D[dim,dim];
        mat := mat2*mat;
        prog := (B.3^B.5)^-1;
    else
        prog := One( B );
    end if;
    
    list := [];
    
    for i in [1..dim-5 by 2] do
        Append( ~list, i );
    end for;
    
    Append( ~list, dim-3 ); Append( ~list, dim-2 );
    
    for i in [dim-4..2 by -2] do
        Append( ~list, i );
    end for;
    
    p := GL( dim-2, q )!PermutationMatrix( GF( q ), Sym( dim-2 )!list );
    
    a, w := OmegaMinusWordInGen( GL( dim-2, q ), 
                    (GL( dim-2, q )!mat)^p );
    assert a;
    prog := prog*Evaluate2( w, 
                    [ B.1, B.2, B.3, B.4^B.5, B.5*B.4^-1 ]);
    
    
    
    return prog, One( B ), One( G );
end function;
    
SmallerMatrixToSLPOmega := function( G, g, mat )
    
    dim := BBDimension( G );
    
    if dim eq 3 then
        return One( B ), One( B ), One( G );
    end if;
    
    F := BBField( G );
    q := #F;
    w := PrimitiveElement( F ); el := Integers()!((q-1)/2 );
          
    form := el*mat[2,1]*mat[dim-2,1]; 
    for i in [2..(dim-1)/2] do
        form := form + mat[2,i]*mat[dim-2,dim-i]+
                mat[2,dim-i]*mat[dim-2,i];
    end for;
    
    if not IsSquare( (F!form)^-1 ) then return false, false, false; end if;
    s := Sqrt( (F!form)^-1 );
    mat := mat*s;
    
    if Determinant( mat ) ne 1 then
        mat := -1*mat;
    end if;
    
    assert Determinant( mat ) eq 1;
    
    formmat := Zero( MatrixAlgebra( F, dim-2 ));
    formmat[1,1] := el;
    for i in [2..dim-2] do
        formmat[i,dim-i] := 1;
    end for;    
    
    prog := One( B );
    
    if SpinorNorm( GL(dim-2,q)!mat, formmat ) ne 0 then
        mat[2] := w*mat[2];
        mat[dim-2] := w^-1*mat[dim-2];
        _, prog := U_( dim, q );
    end if;
    
    assert SpinorNorm( GL(dim-2,q)!mat, formmat ) eq 0;
        
    D := 0;
    
    
    list := [dim-2];
    
    for i in [1..dim-4 by 2] do
        Append( ~list, i );
    end for;
    
    for i in [dim-3..2 by -2] do
        Append( ~list, i );
    end for;
    
    p := GL( dim-2, q )!PermutationMatrix( GF( q ), Sym( dim-2 )!list );
    
    a, w := OmegaCircleWordInGen( SO( dim-2, q ), 
                    (GL( dim-2, q )!mat)^p );
    assert a;
    progU := U_( dim, q );
    w := Evaluate2( w, [B.1,B.2,B.3,B.4*progU^-1] );
    
    return prog^-1*w, One( B ), One( G );
end function;

    
GenOfCenter := function( G )
    
   gens := BBStandardGenerators( G );
   dim := BBDimension( G );
   q := #BBField( G );
   d := gens[6];
   p := gens[8]*gens[4]; 
   
   
   if IsEven( q ) then
       
       return One( G ), One( B );
       
   elif IsEven( Round( (q-1)/2 )) then
       z1 := gens[3]*gens[6]; pz1 := B.3*B.6;
       z := z1; pz := pz1;
       for i in [1..(dim/2)-1] do
           z1 := z1^gens[8]; pz1 := pz1^B.8;
           z := z*z1; pz := pz*pz1;
       end for;
       z := z^Round((q-1)/4); pz := pz^Round((q-1)/4);
       
   elif IsEven( Round( dim/2 )) then
       
       z1 := gens[3]; pz1 := B.3;
       z := z1; pz := pz1;
       for i in [1..(dim/4)-1] do
           z1 := z1^gens[8]^2; pz1 := pz1^B.8^2;
           z := z*z1; pz := pz*pz1;
       end for;
       
       z := z^Round((q-1)/2); pz := pz^Round((q-1)/2);
       
   elif IsOdd( Round( dim/2 )) then
       
       z1 := gens[3]^gens[8]; pz1 := B.3^B.8;
       z := z1; pz := pz1;
       for i in [1..(dim-2)/4-1] do
           z1 := z1^gens[8]^2; pz1 := pz1^B.8^2;
           z := z*z1; pz := pz*pz1;
       end for;
       
       
       z := z^Round((q-1)/2); pz := pz^Round((q-1)/2);

   end if;
   
   return z, pz;
end function;

GenOfCenterOmegaMinus := function( G )
    
    
    gens := BBStandardGenerators( G );
    dim := BBDimension( G );
    q := #BBField( G );
      
    if Round( q^(dim/2)) mod 4 ne 3 then
        return One( G ), One( B );
    end if;
    
    q1 := Round((q-1)/2); dim1 := Round( dim/2-2 );
    d1 := gens[3]^q1; pd1 := B.3^q1;
    d2 := (gens[3]^q1)^gens[5]^-1; pd2 := (B.3^q1)^B.5^-1;
    for i in [1..dim1-1] do
        d1 := d1*d2; pd1 := pd1*pd2;
        d2 := d2^gens[5]^-1; pd2 := pd2^B.5^-1;
    end for;
    d1 := d1*(gens[3]^gens[5])^Round((q+1)/2-q1*dim1);
    pd1 := pd1*(B.3^B.5)^Round((q+1)/2-q1*dim1);
    
    ex := Round(Order( d1 )/2);
    d1 := d1^ex; pd1 := pd1^ex;
    
    return d1, pd1;
    
end function;

    
DiagonalElementToSLPOmegaPlusCharP := function( G, g )
    
   gens := BBStandardGenerators( G );
   D1 := gens[3]; D2 := gens[6];
   T := gens[5];
   el := One( G ); pr := One( B );
   zz := PrimitiveElement( BBField( G ))^2;
   dim := BBDimension( G ); q := #BBField( G );
      
   z, pz := GenOfCenter( G );

   if (g,gens[8]) ne One( G ) then
       _, v := WriteTransvectionAsSLP( G, T^g );
       a := v[1];
       k := Round( Log( zz, a ));
       if k eq -1 then
           g := g*z;
           el := z; pr := pz;
           k := Round( Log( zz, -a ));
       end if;
       el := el*(D1*D2)^k; pr := pr*(B.3*B.6)^k;
       g := g*(D1*D2)^k;
       
   end if;
   
   if g ne One( G ) and q^Round(dim/2) mod 4 eq 1 then
       
       g := g*z;
       el := el*z;
       pr := pr*pz;
   end if;
   
   if (g,gens[8]) ne One( G ) then
       _, v := WriteTransvectionAsSLP( G, T^g );
       a := v[1];
       k := Round( Log( zz, a ));
       el := el*(D1*D2)^k; pr := pr*(B.3*B.6)^k;
       g := g*(D1*D2)^k;
   end if; 
   
   return pr, el;
   
end function;
    
DiagonalElementToSLPOmegaMinus4CharP := function( G, g )
    
    q := #BBField( G );
    stgens := ClassicalStandardGenerators( "Omega-", 4, q );
    _, _, f := OrthogonalForm( sub< GL( 4, q ) | stgens >);
        
    if IsOdd( q ) then
        a := f[3,3]; b := f[4,4];
    else
        a := f[3,4]; b := a;
    end if;
    
    if IsEven( q ) then
        _, Q := QuadraticForm(  sub< GL( 4, q ) | stgens > );
        r := Q[3,4]; s := Q[4,4];
    end if;
    
    gens := BBStandardGenerators( G );
    if IsOdd( q ) then
        T := gens[2]; 
    else
        T := gens[1];
    end if;
    
    p := WriteTransvectionAsSLP( G, T^g );
    stgens :=  ClassicalStandardGenerators( "Omega-", 4, q );
    mat := Evaluate2( p, stgens );
    v := [ mat[1,3],mat[1,4]];
    
    if IsOdd( q ) then
        c := Sqrt( -(v[1]^2*a+v[2]^2*b)/2)^-1;
    else
        c := Sqrt( (v[1]*(v[1]+r*v[2])+v[2]*s*v[2])^-1 );
    end if;
 
    bas1 := stgens[3][1,1];
    ex := Log( bas1, c );
    el := gens[3]^-ex; pr := B.3^-ex;
    g := g*el;
    
    p := WriteTransvectionAsSLP( G, T^g );
    mat := Evaluate2( p, stgens );
    V2 := VectorSpace( GF(q), 2 );
    v1 := V2![ mat[1,3],mat[1,4]];
    
    if IsEven( q ) then
        
        t1 := stgens[1]^stgens[3];
        T1 := gens[1]^gens[3];
        c := t1[1,3]; d := t1[1,4];
        p := WriteTransvectionAsSLP( G, T1^g );
        mat := Evaluate2( p, stgens );
        w := V2![ mat[1,3],mat[1,4]];    
        v2 := (w-c*v1)/d;
        M := MatrixAlgebra( GF( q^2 ), 2 )![ v1[1],v1[2],v2[1],v2[2]];
        
    else
        
        M := MatrixAlgebra( GF( q ), 2 )![ v1[1]*a, v1[2]*b, -v1[2], v1[1] ];
        b := V2![0,1];
        b := M^-1*Transpose( Matrix( b ));
        c := b[1,1]; d := b[2,1];
        M := MatrixAlgebra( GF( q^2 ), 2 )![ v1[1], v1[2], c, d ];
    end if;
    
    a := {@ x[1] : x in Eigenvalues( M ) @}[1];
    
    exp := case< IsOdd( q ) | true: (q-1) div 2, false: q-1, 
           default: false >;
    
    stmat := GL(4,q^2)!(stgens[3])^(exp);
    bas := {@ x[1] : x in Eigenvalues( stmat ) | not x[1] in GF( q ) @}[1];
    
    ex1 := Log( bas, a ); ex2 := Log( bas, a^-1 );
    ex3 := Log( bas, -a ); ex4 := Log( bas, -a^-1 );
    
    el1 := gens[3]^(-ex1*exp); pr1 :=  B.3^-(ex1*exp);
    el2 := gens[3]^(-ex2*exp); pr2 :=  B.3^-(ex2*exp);
    el3 := gens[3]^(-ex3*exp); pr3 :=  B.3^-(ex3*exp);
    el4 := gens[3]^(-ex4*exp); pr4 :=  B.3^-(ex4*exp);
    c := gens[3]^((q-1)*(q+1) div 4); pc := B.3^((q-1)*(q+1) div 4);
    
    els := [ el1, el2, el3, el4, el1*c, el2*c, el3*c, el4*c ];
    prs := [ pr1, pr2, pr3, pr4, pr1*pc, pr2*pc, pr3*pc, pr4*pc ];
    
    gels := [ g*els[x] : x in [1..8] ];
    
    t := exists( x ){ x : x in [1..8] | gels[x] eq One( G ) };
    
    if not t then
        t := exists( x ){ x : x in [1..8] | (gels[x],T) eq One( G ) };
    end if;
    
    if t then
        return pr*prs[x], el*els[x];
    else 
        return false, false;
    end if;
    
        
end function;
    

DiagonalElementToSLPOmegaMinusCharP := function( G, g )
    
   gens := BBStandardGenerators( G );
   dim := BBDimension( G );
   q := #BBField( G );
   d := gens[3];
   
   if dim eq 4 then
       return DiagonalElementToSLPOmegaMinus4CharP( G, g );
   end if;
   
   e := Round( Order( d )/(q-1));
   
   if IsOdd( q ) then
       d3 := (gens[3]^gens[5])^Round(2*Order( gens[3] )/(q-1));
       pd3 := (B.3^B.5)^Round(2*Order( gens[3] )/(q-1));
   else
       d3 := (gens[3]^gens[5])^(q+1);
       pd3 := (B.3^B.5)^(q+1);
   end if;
   
   pos := case< IsEven( q ) | true: 1, false: Round(dim/2), default: false >;
   ex := Evaluate2( pd3, 
                 ClassicalStandardGenerators( "Omega-", 
                         dim, q ))[pos,pos];
   
   p1 := X12_( "Omega-", dim, q );
   T := Evaluate2( p1, gens );
   _, v := WriteTransvectionAsSLP( G, T^g );
   a := v[1];
   e1 := Log( ex, a );
   
   el := d3^e1; pr := pd3^e1;
   g := g*el;
   
   if g eq One( G ) then
       return pr, el;
   else
       q1 := Round((q-1)/2); dim1 := Round( dim/2-2 );
       d1 := gens[3]^q1; pd1 := B.3^q1;
       d2 := (gens[3]^q1)^gens[5]^-1; pd2 := (B.3^q1)^B.5^-1;
       for i in [1..dim1-1] do
           d1 := d1*d2; pd1 := pd1*pd2;
           d2 := d2^gens[5]^-1; pd2 := pd2^B.5^-1;
       end for;
       d1 := d1*(gens[3]^gens[5])^Round((q+1)/2-q1*dim1);
       pd1 := pd1*(B.3^B.5)^Round((q+1)/2-q1*dim1);
       _, v := WriteTransvectionAsSLP( G, T^g );
       a := v[1];
       e1 := Log( PrimitiveElement( GF( q )), a );
       g := g*d1^-e1;
       pr := pr*pd1^-e1; el := el*d1^-e1;
   end if;
   
   _, v := WriteTransvectionAsSLP( G, T^g );
   a := v[1];
   e1 := Log( PrimitiveElement( GF( q ))^2, a );
   el := el*d3^e1; pr := pr*pd3^e1;
   g := g*d3^e1;

   if g eq One( G ) then
       return pr, el;
   else
       z, pz := GenOfCenterOmegaMinus( G );
       return pr*pz, el*z;
   end if;
   
end function;  
    
DiagonalElementToSLPOmega3CharP := function( G, g )
    
    gens := BBStandardGenerators( G );
    dim := BBDimension( G );
    q := #BBField( G );
      _, _, d := IsPrimePower( q ); 
    stgens := ClassicalStandardGenerators( "Omega", 3, q );
        
    
    _, v := WriteTransvectionAsSLP( G, gens[2]^g );
    
    a := v[1]/stgens[2][1,3];
    z := PrimitiveElement( GF( q ));
    k := -Log( stgens[3][1,1], a^-1 );
    
    return B.3^k, gens[3]^k;
end function;
    
    
DiagonalElementToSLPOmegaCharP := function( G, g )
    
    gens := BBStandardGenerators( G );
   dim := BBDimension( G );
   q := #BBField( G );
     
   if dim eq 3 then
       return DiagonalElementToSLPOmega3CharP( G, g );
   end if;
     
   _, _, d := IsPrimePower( q ); 
   
   if dim gt 3 then
       p := PSubgroup( G ).(d+1);
   else 
       p := PSubgroup( G ).1;
   end if;
   
   _, v := WriteTransvectionAsSLP( G, p^g );
   
   a := v[2]^-1;
   z := PrimitiveElement( GF( q ));
   
   k := -Log( z^2, a );
      
   return (B.3^k)^B.4, (gens[3]^k)^gens[4];
end function;
    
