freeze;

import "../../recformat.m": SporadicRF;
import "../../List.m": ListMaximals;
import "../../BlackBoxes/Autm/Fi22.m":StandardGeneratorsFi22Autm;

/* generators for maximal subgroups of Fi22:2 */

GeneratorsFi22AutmMax1 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w4*w4;
w2:=w4*w5;
w4:=w3*w3;
w5:=w3*w4;
w3:=w4*w5;
w4:=w3^-1;
w5:=w4*w1;
w1:=w5*w3;

   return [w1,w2];

end function;

GeneratorsFi22AutmMax2 := function (a,b)

   w1 := a; w2 := b;

w3:=w2^5;
w4:=w2*w1;
w5:=w3*w1;
w6:=w5*w2;
w7:=w2*w2;
w2:=w1*w3;
w5:=w3*w7;
w1:=w5*w7;
w5:=w2*w3;
w3:=w4*w6;
w2:=w5*w3;
w3:=w2^3;
w5:=w6*w7;
w6:=w5*w4;
w2:=w6^-1;
w4:=w2*w3;
w2:=w4*w6;

   return [w1,w2];

end function;

GeneratorsFi22AutmMax3 := function (a,b)

   w1 := a; w2 := b;

w3:=w2^15;
w4:=w2^4;
w2:=w4*w1;
w5:=w2*w3;
w3:=w5*w1;
w2:=w3*w4;

   return [w1,w2];

end function;

GeneratorsFi22AutmMax4 := function (a,b)

   w1 := a; w2 := b;

w3:=w2*w2;
w4:=w3^7;
w5:=w3*w3;
w6:=w1*w2;
w7:=w1*w5;
w8:=w1*w3;
w9:=w8*w6;
w10:=w6^3;
w11:=w10*w2;
w5:=w11*w11;
w10:=w6*w9;
w11:=w1*w4;
w1:=w11*w7;
w4:=w1*w2;
w1:=w4*w6;
w4:=w7*w8;
w6:=w4*w2;
w4:=w3*w10;
w3:=w4*w10;
w4:=w3*w2;
w3:=w4*w9;
w4:=w3*w5;
w2:=w4^-1;
w3:=w2*w6;
w2:=w3*w4;

   return [w1,w2];

end function;

GeneratorsFi22AutmMax5 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w2*w2;
w6:=w5*w2;
w7:=w5*w5;
w8:=w7*w7;
w9:=w8*w8;
w10:=w2^14;
w1:=w3*w8;
w11:=w4*w3;
w12:=w3*w9;
w13:=w4*w8;
w14:=w4*w7;
w15:=w7*w13;
w16:=w15*w15;
w17:=w5*w16;
w18:=w17*w11;
w16:=w18^-1;
w17:=w12*w11;
w15:=w16*w17;
w2:=w15*w18;
w16:=w6*w4;
w15:=w16*w5;
w16:=w15*w12;
w15:=w16*w9;
w16:=w15*w3;
w19:=w16*w7;
w15:=w14^3;
w16:=w19^-1;
w17:=w16*w15;
w3:=w17*w19;

   return [w1,w2];

end function;

GeneratorsFi22AutmMax6 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w2*w3;
w5:=w3*w4;
w6:=w2^10;
w2:=w5*w4;
w7:=w2^3;
w2:=w4*w6;
w6:=w2*w4;
w2:=w6^-1;
w4:=w2*w7;
w2:=w4*w6;
w4:=w5*w5;
w5:=w3*w3;
w3:=w4*w5;
w1:=w3^12;

   return [w1,w2];

end function;

GeneratorsFi22AutmMax7 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w2*w2;
w5:=w4*w4;
w6:=w2*w3;
w7:=w3*w5;
w8:=w5^3;
w9:=w7*w6;
w5:=w4*w9;
w1:=w3*w4;
w4:=w1*w6;
w1:=w4*w6;
w4:=w7*w8;
w7:=w4*w9;
w4:=w5*w6;
w5:=w4*w8;
w4:=w5*w3;
w3:=w4*w2;
w2:=w3^-1;
w4:=w2*w7;
w2:=w4*w3;

   return [w1,w2];

end function;

GeneratorsFi22AutmMax8 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w4*w3;
w4:=w5*w5;
w5:=w3^3;
w2:=w4*w5;

   return [w1,w2];

end function;

GeneratorsFi22AutmMax9 := function (a,b)

   w1 := a; w2 := b;

w3:=w2^4;
w4:=w3^4;
w5:=w2^3;
w6:=w1*w4;
w7:=w1*w2;
w4:=w1*w3;
w8:=w4*w5;
w4:=w7*w7;
w2:=w1*w5;
w1:=w8*w4;
w4:=w3*w6;
w3:=w4*w2;
w4:=w3*w7;
w3:=w6*w6;
w5:=w3*w7;
w2:=w4^-1;
w3:=w2*w5;
w2:=w3*w4;

   return [w1,w2];

end function;

GeneratorsFi22AutmMax10 := function (a,b)

   w1 := a; w2 := b;

w3:=w2^7;
w4:=w1*w3;
w5:=w4*w3;
w6:=w2*w1;
w7:=w2*w2;
w8:=w5*w6;
w9:=w8*w7;
w1:=w9^3;
w3:=w2*w5;
w8:=w3*w5;
w3:=w8*w7;
w5:=w3*w6;
w2:=w4^3;
w3:=w5^-1;
w4:=w3*w2;
w2:=w4*w5;

   return [w1,w2];

end function;

GeneratorsFi22AutmMax11 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w4*w3;
w6:=w4*w5;
w5:=w2*w2;
w3:=w4*w5;
w7:=w6^3;
w2:=w3*w5;
w5:=w4*w3;
w3:=w2*w5;
w2:=w3^-1;
w5:=w2*w7;
w2:=w5*w3;
w3:=w4*w6;
w1:=w3^15;

   return [w1,w2];

end function;

GeneratorsFi22AutmMax12 := function (a,b)

   w1 := a; w2 := b;

w3:=w2*w1;
w4:=w3*w3;
w3:=w2*w4;
w4:=w3*w2;
w2:=w3*w4;

   return [w1,w2];

end function;

GeneratorsFi22AutmMax13 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w2*w2;
w5:=w3*w4;
w6:=w5*w4;
w7:=w6*w4;
w1:=w5^15;
w5:=w4^8;
w4:=w7^4;
w8:=w5*w7;
w5:=w8*w2;
w2:=w5*w6;
w5:=w2*w3;
w2:=w5^-1;
w3:=w2*w4;
w2:=w3*w5;

   return [w1,w2];

end function;

/* list of subgroups of Fi22:2 */

DataFi22Autm := function ()

   F<a, b> := SLPGroup (2);
   
   L := [
   rec <SporadicRF | name := "Fi22:2", generators := [a, b], order := 129123503308800>,
   
   rec <SporadicRF | name := "Fi22", parent := "Fi22:2", generators := 
   GeneratorsFi22AutmMax1(a,b), order := 64561751654400, index := 2>,
   
   rec <SporadicRF | name := "2.PSU(6,2).2", parent := "Fi22:2", generators := 
   GeneratorsFi22AutmMax2(a,b), order := 36787322880, index := 3510>,
   
   rec <SporadicRF | name := "O8+(2):S3x2", parent := "Fi22:2", generators := 
   GeneratorsFi22AutmMax3(a,b), order := 2090188800, index := 61776>,
   
   rec <SporadicRF | name := "2^10:M22:2", parent := "Fi22:2", generators := 
   GeneratorsFi22AutmMax4(a,b), order := 908328960, index := 142155>,
   
   rec <SporadicRF | name := "2^7:S6(2)", parent := "Fi22:2", generators := 
   GeneratorsFi22AutmMax5(a,b), order := 185794560, index := 694980>,
   
   rec <SporadicRF | name := "(2x2^{1+8}:PSU(4,2):2):2", parent := "Fi22:2", generators := 
   GeneratorsFi22AutmMax6(a,b), order := 106168320, index := 1216215>,
   
   rec <SporadicRF | name := "PSU(4,3).2.2xS3", parent := "Fi22:2", generators := 
   GeneratorsFi22AutmMax7(a,b), order := 78382080, index := 1647360>,
   
   rec <SporadicRF | name := "2F4(2)", parent := "Fi22:2", generators := 
   GeneratorsFi22AutmMax8(a,b), order := 35742400, index := 3612614>,
   
   rec <SporadicRF | name := "2^{5+8}:(S3xS6)", parent := "Fi22:2", generators := 
   GeneratorsFi22AutmMax9(a,b), order := 35389440, index := 3648645>,
   
   rec <SporadicRF | name := "3^5:(2xPSU(4,2):2)", parent := "Fi22:2", generators := 
   GeneratorsFi22AutmMax10(a,b), order := 25194240, index := 5125120>,
   
   rec <SporadicRF | name := "3^{1+6}:2^{3+4}:3^2.2.2", parent := "Fi22:2", generators := 
   GeneratorsFi22AutmMax11(a,b), order := 10077696, index := 12812800>,
   
   rec <SporadicRF | name := "G2(3):2", parent := "Fi22:2", generators := 
   GeneratorsFi22AutmMax12(a,b), order := 8491392, index := 15206400>,
   
   rec <SporadicRF | name := "M12:2", parent := "Fi22:2", generators := 
   GeneratorsFi22AutmMax13(a,b), order := 7257600, index := 17791488>

   ];
   
   return L;
   
end function;

/* code to find standard generators of Fi22:2 and produce listing of maximal subgroups */

MaximalsFi22Autm := function (G)

   x, y := StandardGeneratorsFi22Autm(G);
   if Type(x) eq BoolElt then "Unable to find Standard Generators"; return false; end if;

   G := sub<G|x[1],x[2]>;
   return ListMaximals(G, "Fi22:2", DataFi22Autm());

end function;

