freeze;

import "../../recformat.m": SporadicRF;
import "../../List.m": ListMaximals;
import "../../BlackBoxes/Autm/M22.m":StandardGeneratorsM22Autm;

/* generators for maximal subgroups of M22.2 */

GeneratorsM22AutmMax1 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w3*w4;
w6:=w3*w5;
w7:=w6*w3;
w1:=w2*w2;
w2:=w7*w7;
w5:=w4^-1;
w6:=w5*w2;
w2:=w6*w4;

   return [w1,w2];

end function;

GeneratorsM22AutmMax2 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w2*w3;
w5:=w3*w4;
w6:=w5*w5;
w5:=w2*w4;
w4:=w5*w3;
w2:=w4^-1;
w3:=w2*w6;
w2:=w3*w4;

   return [w1,w2];

end function;

GeneratorsM22AutmMax3 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w2*w3;
w5:=w3*w4;
w6:=w5*w5;
w3:=w2*w4;
w2:=w3^-1;
w4:=w2*w6;
w2:=w4*w3;

   return [w1,w2];

end function;

GeneratorsM22AutmMax4 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w2*w3;
w5:=w3*w4;
w6:=w5*w4;
w4:=w3*w3;
w2:=w4^-1;
w3:=w2*w6;
w2:=w3*w4;

   return [w1,w2];

end function;

GeneratorsM22AutmMax5 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w1;
w1:=w2*w2;
w5:=w1*w3;
w6:=w2*w3;
w7:=w1*w4;
w4:=w5*w5;
w5:=w6*w3;
w8:=w6*w7;
w6:=w5*w4;
w4:=w6*w8;
w5:=w3*w2;
w3:=w4^-1;
w6:=w3*w5;
w2:=w6*w4;

   return [w1,w2];

end function;

GeneratorsM22AutmMax6 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w4*w4;
w2:=w5*w3;

   return [w1,w2];

end function;

GeneratorsM22AutmMax7 := function (a,b)

   w1 := a; w2 := b;

w3:=w1*w2;
w4:=w3*w2;
w5:=w4*w3;
w1:=w5^5;
w5:=w4*w4;
w6:=w2*w3;
w3:=w6*w4;
w2:=w3^-1;
w4:=w2*w5;
w2:=w4*w3;

   return [w1,w2];

end function;


/* list of subgroups of M22:2 */

DataM22Autm := function ()

   F<a, b> := SLPGroup (2);
   
   L := [
   rec <SporadicRF | name := "M22:2", generators := [a, b], order := 887040>,
   
   rec <SporadicRF | name := "M22", parent := "M22:2", generators := 
   GeneratorsM22AutmMax1(a,b), order := 443520, index := 2>,
   
   rec <SporadicRF | name := "PSL(3,4):2", parent := "M22:2", generators := 
   GeneratorsM22AutmMax2(a,b), order := 40320, index := 22>,
   
   rec <SporadicRF | name := "2^4:S6", parent := "M22:2", generators := 
   GeneratorsM22AutmMax3(a,b), order := 11520, index := 77>,
   
   rec <SporadicRF | name := "2^5:S5", parent := "M22:2", generators := 
   GeneratorsM22AutmMax4(a,b), order := 3840, index := 231>,
   
   rec <SporadicRF | name := "2^3:PSL(3,2)x2", parent := "M22:2", generators := 
   GeneratorsM22AutmMax5(a,b), order := 2688, index := 330>,
   
   rec <SporadicRF | name := "A6.2", parent := "M22:2", generators := 
   GeneratorsM22AutmMax6(a,b), order := 1440, index := 616>,
   
   rec <SporadicRF | name := "PSL(2,11):2", parent := "M22:2", generators := 
   GeneratorsM22AutmMax7(a,b), order := 1320, index := 672>

   ];
   
   return L;
   
end function;

/* code to find standard generators of M22:2 and produce listing of maximal subgroups */

MaximalsM22Autm := function (G)

   x, y := StandardGeneratorsM22Autm(G);
   if Type(x) eq BoolElt then "Unable to find Standard Generators"; return false; end if;
	
   G := sub<G|x[1],x[2]>;
   return ListMaximals(G, "M22:2", DataM22Autm());

end function;
