freeze;

declare attributes GrpAuto :
    RepGroup,               /* Preferred representation for automorphim group */
    RepMap,                 /* Map for RepGroup (GrpAuto -> RepGroup) */
    MapToRepElt,            /* UserProgram which takes an arbitrary map and constructs elt of RepGroup */
    MatrixGroup,            /* Matrix group representation */
    RepEltToMap,            /* Take an elt of RepGroup and construct map (faster than RepMap^-1 for matrix rep) */
    PCRepData,              /* Record used to hold process_data when constructing PC reps */
    PCGenerators;           /* SetIndx containing pc-generators for soluble automorphim group */

/* Verbose flag for automorphism/isomorphism code for soluble groups */
declare verbose AutomorphismGroupSolubleGroup, 3;

/* Verbose flags for config */
/* Enable computation of AutK where AutS is soluble */
declare verbose AutomorphismGroupSolubleGroupComputeAutK, 1;
/* Disable computation of AutSKN (orbit-sabilizer) */
declare verbose AutomorphismGroupSolubleGroupDoNotComputeAutSKN, 1;
/* Overrides the orbit limit in the AutSKN computation */
declare verbose AutomorphismGroupSolubleGroupAutSKNIgnoreOrbitLimit, 1;

/* Config values */
AutomorphismGroupSolubleGroup_ComputeAutSKN_OrbitLimit := 2^9;