freeze;
MatrixToAuto := function (G, m)

   d := Degree (m);
   return [G!m[i] : i in [1..d]];

end function;

/* given Auts, a collection of matrices acting on H, extend
   to act on the extension P, and return the matrices
   which describe the action on the subgroup S */

ExtendAutomorphisms := function (P, H, Auts, S)

   if #Auts eq 0 then return Auts; end if;

   FACTOR := 100;

   p := FactoredOrder (P)[1][1];
   d := #Generators (P);

   theta := hom <P -> H | [<P.i, H.i> : i in [1..d]] >;

   q := NPCgens (S); gl := GL (q, p); M := [];

   /* extend the automorphisms of H to act on the p-covering group */
   vprint ClassTwo: "Number of reps is ", #Auts;
   for j in [1..#Auts] do
      if j mod FACTOR eq 1 then 
         vprint ClassTwo: "Processing automorphism j = ", j; 
      end if;
      // alpha := MatrixToAuto (H, Auts[j]);
      alpha := [H!Auts[j][i] : i in [1..q]];
      h := [<P.i, alpha[i] @@ theta>: i in [1..d]]; 
      beta := p_hom (P, P, h, P`definitions); 
      M[j] := gl ! &cat[Eltseq (S!(beta (S.i))): i in [1..q]];
   end for;

   return M;

end function;
